#include <iostream>
#include <stack>
using namespace std;

const int Dim = 100001;

int v[Dim], n;
int w[Dim];   // sirul cerut
stack<int> stk;

int main()
{
    cin >> n;
    
    for (int i = 1; i <= n; ++i)
    {
		cin >> v[i];
		
        while (!stk.empty() && v[i] > v[stk.top()])
        {
            w[stk.top()] = v[i]; // valoarea elementului aflat pe pozitia din varful stivei 
            stk.pop();
        }
        
        stk.push(i);
    }
    
    while (!stk.empty())
    {
        w[stk.top()] = -1;
        stk.pop();
	}
        
    for (int i = 1; i <= n; ++i)
        cout << w[i] << ' ';
    return 0;
}
